unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 : TForm1;
  HD    : integer;
  SProc : procedure;

  Fin        : file;
  Fout       : file;
  summt      : byte = 0;
  otv1       : byte = 0;
  otv2       : byte = 0;
  rg         : integer = 0;
  psp        : byte = 0;
  MasFileIn  : PByteArray;
  MasFileOut : PByteArray;
  MasPsP     : PByteArray;
  i          : integer = 0;
  k          : integer = 0;
  LFileIn    : integer =0;

implementation

{$R *.dfm}

procedure TForm1.Button2Click(Sender: TObject);
begin
HD:=LoadLibrary(PChar('cracdll.dll'));
if HD <> 0 then
 begin
  SProc:= GetProcAddress(HD,PChar('Proc'));
  if (@SProc <> nil) then  Sproc else
   ShowMessage('Registred function not found !');
 end
else ShowMessage('Dll Not found !');
end;

procedure TForm1.Button1Click(Sender: TObject);

var key:integer;

begin
summt      := 0;
otv1       := 0;
otv2       := 0;
rg         := 0;
psp        := 0;
i          := 0;
k          := 0;
LFileIn    := 0;
AssignFile(Fin,'cracdll.dll');
Reset(Fin,1);
LFileIn:=FileSize(Fin);
GetMem(MasFileIn,LFileIn);
GetMem(MasFileOut,LFileIn);
GetMem(MasPsP,LFileIn);
ZeroMemory(MasFileIn,LFileIn);
ZeroMemory(MasFileOut,LFileIn);
ZeroMemory(MasPsP,LFileIn);
BlockRead(Fin,MasFileIn^,LFileIn);
CloseFile(Fin);
rg:=strtoint(Edit1.Text);
repeat
 repeat
  if (rg and 1) = 1 then otv1:= 1
   else otv1:= 0;
  if (rg and 2) = 2 then otv2:= 1
   else otv2:= 0;
  summt:=otv1 xor otv2;
  rg:= rg shr 1;
  if summt = 1 then rg:= rg or 2147483648;
  psp:=psp shr 1;
  if summt = 1 then psp:=psp or 128;
  inc(i);
 until i = 8;
i:=0;
MasPsP^[k]:= psp;
psp:=0;
inc(k);
until k = LFileIn;

k:=0;
 repeat
  MasFileOut^[k]:= MasFileIn^[k] xor MasPsP^[k];
  inc(k);
 until k = LFileIn;

key:=0;
copymemory(@key,Pointer(MasFileOut),4);
if key = 5265997 then begin
                       AssignFile(Fout,'cracdll.dll');
                       Rewrite(Fout,1);
                       BlockWrite(Fout,MasFileOut^,LFileIn);
                       CloseFile(Fout);
                       Button2.Enabled:=true;
                       ShowMessage('Registred !');
                      end
else ShowMessage('Not registred !');
FreeMem(MasFileIn);
FreeMem(MasFileOut);
FreeMem(MasPsP);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if HD <> 0 then FreeLibrary(HD);
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
case key of
    '0'..'9': ; // 
    #8: ; // 
    '.', ',':
      if Pos(DecimalSeparator, Text) = 0 then
        Key := DecimalSeparator
      else
        Key := #0; //  
    else
      key := #0;
  end; // case

end;

end.
